Codeforces Round #529 (Div. 3)A-F

A题:https://codeforces.com/contest/1095/problem/A

题解:

按照题目要求模拟一个类似指针的东西,每次加i即可知道指针超过输入长度

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
const int N=3e5+7;
const long long mod=1e9+7;
char str[N];
int main(){

    int n;
    scanf("%d",&n);
    scanf("%s",str);
    int tot=1;
    int i=0;
    while(i<n){
        printf("%c",str[i]);
        i+=tot;
        tot++;
    }
    //puts("");
    return 0;
}

B题:https://codeforces.com/contest/1095/problem/B

题解:

题目要求我们删掉数列中其中一个元素,后求删去后的数列中最大值减去最小值。

题目给的n是小于1e5的所以可以sort后求min(que[n-1]-que[1],que[n]-que[2])即可求出解。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
const int N=3e5+7;
const long long mod=1e9+7;
int a[N];
int main(){
    int n;
    scanf("%d",&n);
    for(int i=1;i<=n;i++){
        scanf("%d",&a[i]);
    }
    sort(a+1,a+1+n);
    printf("%d\n",min(a[n-1]-a[1],a[n]-a[2]));
    return 0;
}

C题:https://codeforces.com/contest/1095/problem/C

题解:

给出一个数n和一个数k问有没有使得用k个2的次幂的数组成和为n的情况。

先将n进行2进制分解,对于每位上存在的数,都可以由2个下一位的数求出,因此,我们只要从最高为进行枚举,若此时各个位上的数的总和ans<k,且该位上存在数,则将该位的个数--,下一位上的个数+=2,ans++。直到ans==k退出

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
const int N=3e5+7;
const long long mod=1e9+7;
int arr[50];
int main(){
    int n,k;
    int ti=0;
    int ans=0;
    scanf("%d%d",&n,&k);
    while(n){
        ti++;
        if(n%2==0){
            arr[ti]=0;
        }
        else {
            arr[ti]=1;
            ans++;
        }
        n/=2;
    }
    for(int i=ti;i>=2;i--){
        if(!arr[i]) continue;
        if(ans==k) break;
        while(arr[i]){
            if(ans<k){
                arr[i]--;
                arr[i-1]+=2;
                ans++;
            }
            else break;
        }
    }
    if(ans!=k) puts("NO");
    else {
        puts("YES");
        for(int i=1;i<=ti;i++){
            int tmp=(1<<(i-1));
            while(arr[i]){
                printf("%d ",tmp);
                arr[i]--;
            }
        }
    }
    return 0;
}

D题:https://codeforces.com/contest/1095/problem/D

题解:

题目信息已知每个小朋友记得自己前2位的小朋友是谁,让我们把这个顺序求出来。

很容易可以得到这样的一个信息即当我们已知一个小朋友的位置,为了确定该小朋友下一个小朋友是谁,只要知道该小朋友的下两个人中,他们各自的下两个人有没有对方即可,比如序列2 5 3   2的前2位有5 3,5的前两位必定会有3,而3的前两位必定没5(n=3的情况特判)

知道这个信息,只要从1号小朋友开始模拟即可,直到最后一个小朋友是1号结束。(n=3特判,即n位3时任意一种排法都符合任意的给出的信息条件)

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
const int N=3e5+7;
const long long mod=1e9+7;
int a[N][3],arr[N],tot;
void dfs(int x){
    int u=a[x][1];
    int v=a[x][2];
    if(a[u][1]==v||a[u][2]==v){
        arr[++tot]=u;
        if(u==1) return;
        dfs(u);
    }
    else {
        arr[++tot]=v;
        if(v==1) return;
        dfs(v);
    }
}
int main(){
    int n;
    scanf("%d",&n);
    tot=0;
    for(int i=1;i<=n;i++){
        scanf("%d%d",&a[i][1],&a[i][2]);
    }
    dfs(1);
    if(n==3) {
        puts("1 2 3");
        return 0;
    }
    for(int i=1;i<=tot;i++){
        printf("%d",arr[i]);
        if(i==n) puts("");
        else printf(" ");
    }
    return 0;
}

E题:https://codeforces.com/contest/1095/problem/E

题解:

给出一列括号,如果改变第i位的括号可以使整列括号合法,则该位括号是可以改变的括号,问一共有多少中这样的括号

首先考虑改变的那个括号为‘(’的情况

1.将该列括号从左往右搜,遇到‘(’ dp[i]=dp[i-1]+1  遇到‘)’dp[i]=dp[i-1]-1。这样如果最后的结果是0且当中没出现过负数则说明不用改变即合法。

2.若改变其中一个左括号,该数相应的后面的所有的dp值都会减去2。

知道上述两条件后,我们可以得出一个结论即:当dp[n]=2时,且1-n中的dp值不存在负数的情况,我们可以改变其中一个左括号使得满足1条件。而有多少个左括号可以改变,则可以从2条件中得到相应信息即若改变的i位置后面的dp值中存在0或者1的情况,当我改变i位置的括号会导致后面一些dp值出现负数,即不合法,因此统计个数时,统计从最后一次0或1出现的位置,向后枚举出‘(’的数量即为答案。

右括号同理

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
const int N=2e6+7;
const long long mod=1e9+7;
char str[N];
struct node{
    int ch;
    int wei;
}now;
int dp[N];
int DP[N];
int main(){
    int n;
    scanf("%d",&n);
    scanf("%s",str+1);
    for(int i=1;i<=n;i++){
        now.ch=str[i];
        now.wei=i;
        if(str[i]=='(') dp[i]=dp[i-1]+1;
        else dp[i]=dp[i-1]-1;
        if(str[n-i+1]==')') DP[i]=DP[i-1]+1;
        else DP[i]=DP[i-1]-1;
    }
    /*for(int i=1;i<=n;i++) cout<<DP[i]<<' ';
    cout<<endl;*/
    if(dp[n]==-2){
        int maxn=0;
        bool mark=true;
        for(int i=1;i<=n;i++){
            if(DP[i]<0) mark=false;
            else if(DP[i]<=1){
                maxn=0;
            }
            else {
                if(str[n-i+1]==')') maxn++;
            }
        }
        if(mark) printf("%d\n",maxn);
        else printf("0\n");
    }
    else if(dp[n]==2){
        int maxn=0;
        bool mark=true;
        for(int i=1;i<=n;i++){
            if(dp[i]<0) mark=false;
            else if(dp[i]<=1){
                maxn=0;
            }
            else {
                if(str[i]=='(') maxn++;
            }
        }
        if(mark) printf("%d\n",maxn);
        else printf("0\n");
    }

    else puts("0");
    return 0;
}

F题:https://codeforces.com/contest/1095/problem/F

题解:

按题意可知,只要将给出点权最小的点与其他点相连,并加上题目给出的特殊边,跑一个最小生成树即可。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
const int N=3e5+7;
const long long mod=1e9+7;
struct node{
    int u,v;
    long long w;
}que[N*2];
int fa[N*2];
long long a[N];
bool cmp(node a,node b){
   return a.w<b.w;
}
int cha(int x){
    if(fa[x]==x) return x;
    return fa[x]=cha(fa[x]);
}
int main(){
    int n,m;
    int u,v;
    long long w;
    int tot=0;
    int zi;
    for(int i=1;i<=400000;i++){
        fa[i]=i;
    }
    scanf("%d%d",&n,&m);
    long long minn=10000000000000;
    for(int i=1;i<=n;i++){
        scanf("%lld",&a[i]);
        if(minn>a[i]){
            minn=a[i];
            zi=i;
        }
    }
    while(m--){
        scanf("%d%d%lld",&u,&v,&w);
        que[++tot].u=u,que[tot].v=v,que[tot].w=w;
    }
    for(int i=1;i<=n;i++){
        if(zi==i) continue;
        que[++tot].u=zi,que[tot].v=i,que[tot].w=a[i]+a[zi];
    }
    sort(que+1,que+tot+1,cmp);
    long long res=0;
    int ans=0;
    for(int i=1;i<=tot;i++){
        if(ans==n-1) break;
        int x=cha(que[i].u);
        int y=cha(que[i].v);
        if(x!=y) {
            fa[y]=x;
            ans++;
            res+=que[i].w;
        }
    }
    printf("%lld\n",res);
    return 0;
}

 

 

评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值